
public abstract class Class515_Sub1 extends Class515 {

   public Class241 aClass241_8441;
   Class515_Sub1 aClass515_Sub1_8442;
   public byte aByte8443;
   public byte aByte8444;
   int anInt8445;
   public Class89[] aClass89Array8446;


   void method13390(int var1) {
      this.aClass89Array8446 = new Class89[var1];

      for(int var2 = 0; var2 < this.aClass89Array8446.length; ++var2) {
         this.aClass89Array8446[var2] = new Class89();
      }

   }

   abstract boolean method13391(Class545 var1, int var2, int var3, int var4);

   int method13392(int var1) {
      return 0;
   }

   abstract boolean method13393();

   abstract boolean method13394(byte var1);

   abstract void method13395(Class545 var1, Class515_Sub1 var2, int var3, int var4, int var5, boolean var6);

   abstract void method13396(Class545 var1, Class515_Sub1 var2, int var3, int var4, int var5, boolean var6);

   abstract void method13397(int var1);

   abstract Class579 method13398(Class545 var1, byte var2);

   abstract int method13399(Class225_Sub40[] var1);

   public abstract Class571 method13400(Class545 var1, int var2);

   abstract int method13401(Class225_Sub40[] var1, int var2);

   abstract void method13402(Class545 var1, int var2);

   abstract boolean method13403(short var1);

   public abstract int method13404(byte var1);

   int method13405(int var1, int var2, Class225_Sub40[] var3, short var4) {
      long var5 = this.aClass241_8441.aLongArrayArrayArray2914[this.aByte8443][var1][var2];
      long var7 = 0L;

      int var9;
      int var10;
      for(var9 = 0; var7 <= 48L; var7 += 16L) {
         var10 = (int)(var5 >> (int)var7 & 65535L);
         if(var10 <= 0) {
            break;
         }

         var3[var9++] = this.aClass241_8441.aClass230Array2921[var10 - 1].aClass225_Sub40_2649;
      }

      for(var10 = var9; var10 < 4; ++var10) {
         var3[var10] = null;
      }

      return var9;
   }

   public int method13406(int var1) {
      return -this.method13404((byte)-40);
   }

   abstract void method13407();

   void method13408(int var1, int var2) {
      this.aClass89Array8446 = new Class89[var1];

      for(int var3 = 0; var3 < this.aClass89Array8446.length; ++var3) {
         this.aClass89Array8446[var3] = new Class89();
      }

   }

   abstract boolean method13409();

   abstract boolean method13410();

   abstract boolean method13411();

   abstract void method13412(Class545 var1);

   abstract boolean method13413();

   public abstract int method13414();

   public abstract int method13415();

   public abstract Class571 method13416(Class545 var1);

   public int method13417() {
      return -this.method13404((byte)33);
   }

   public int method13418() {
      return -this.method13404((byte)-78);
   }

   abstract Class579 method13419(Class545 var1);

   void method13420(int var1) {
      this.aClass89Array8446 = new Class89[var1];

      for(int var2 = 0; var2 < this.aClass89Array8446.length; ++var2) {
         this.aClass89Array8446[var2] = new Class89();
      }

   }

   abstract void method13421(Class545 var1);

   abstract void method13422(Class545 var1);

   abstract boolean method13423(byte var1);

   abstract void method13424(Class545 var1, Class515_Sub1 var2, int var3, int var4, int var5, boolean var6, int var7);

   abstract int method13425(Class225_Sub40[] var1);

   abstract boolean method13426();

   abstract boolean method13427();

   abstract boolean method13428(Class545 var1, int var2);

   abstract void method13429();

   abstract void method13430();

   abstract boolean method13431();

   abstract void method13432(Class545 var1);

   int method13433() {
      return 0;
   }

   void method13434(int var1) {
      this.aClass89Array8446 = new Class89[var1];

      for(int var2 = 0; var2 < this.aClass89Array8446.length; ++var2) {
         this.aClass89Array8446[var2] = new Class89();
      }

   }

   static void method13435(Class571 var0, int var1, int var2, int var3, Class568 var4) {
      if(null != var4) {
         var0.method12187(var1, var2, var3, var4.N(), var4.RA(), var4.ya(), var4.YA(), var4.o(), var4.AA(), var4.ha());
      }
   }

   abstract int method13436(Class225_Sub40[] var1);

   abstract boolean method13437(Class545 var1);

   abstract boolean method13438(Class545 var1);

   static void method13439(Class571 var0, int var1, int var2, int var3, Class568 var4) {
      if(null != var4) {
         var0.method12187(var1, var2, var3, var4.N(), var4.RA(), var4.ya(), var4.YA(), var4.o(), var4.AA(), var4.ha());
      }
   }

   int method13440(int var1, int var2, Class225_Sub40[] var3) {
      long var4 = this.aClass241_8441.aLongArrayArrayArray2914[this.aByte8443][var1][var2];
      long var6 = 0L;

      int var8;
      int var9;
      for(var8 = 0; var6 <= 48L; var6 += 16L) {
         var9 = (int)(var4 >> (int)var6 & 65535L);
         if(var9 <= 0) {
            break;
         }

         var3[var8++] = this.aClass241_8441.aClass230Array2921[var9 - 1].aClass225_Sub40_2649;
      }

      for(var9 = var8; var9 < 4; ++var9) {
         var3[var9] = null;
      }

      return var8;
   }

   int method13441(int var1, int var2, Class225_Sub40[] var3) {
      long var4 = this.aClass241_8441.aLongArrayArrayArray2914[this.aByte8443][var1][var2];
      long var6 = 0L;

      int var8;
      int var9;
      for(var8 = 0; var6 <= 48L; var6 += 16L) {
         var9 = (int)(var4 >> (int)var6 & 65535L);
         if(var9 <= 0) {
            break;
         }

         var3[var8++] = this.aClass241_8441.aClass230Array2921[var9 - 1].aClass225_Sub40_2649;
      }

      for(var9 = var8; var9 < 4; ++var9) {
         var3[var9] = null;
      }

      return var8;
   }

   static Class571 method13442(int var0, int var1, int var2, Class568 var3) {
      if(null == var3) {
         return null;
      } else {
         Class571 var4 = new Class571(var0, var1, var2, var3.N(), var3.RA(), var3.ya(), var3.YA(), var3.o(), var3.AA(), var3.ha());
         return var4;
      }
   }

   static Class571 method13443(int var0, int var1, int var2, Class568 var3) {
      if(null == var3) {
         return null;
      } else {
         Class571 var4 = new Class571(var0, var1, var2, var3.N(), var3.RA(), var3.ya(), var3.YA(), var3.o(), var3.AA(), var3.ha());
         return var4;
      }
   }

   static Class571 method13444(int var0, int var1, int var2, Class568 var3) {
      if(null == var3) {
         return null;
      } else {
         Class571 var4 = new Class571(var0, var1, var2, var3.N(), var3.RA(), var3.ya(), var3.YA(), var3.o(), var3.AA(), var3.ha());
         return var4;
      }
   }

   static Class571 method13445(int var0, int var1, int var2, Class568 var3) {
      if(null == var3) {
         return null;
      } else {
         Class571 var4 = new Class571(var0, var1, var2, var3.N(), var3.RA(), var3.ya(), var3.YA(), var3.o(), var3.AA(), var3.ha());
         return var4;
      }
   }

   static void method13446(Class571 var0, int var1, int var2, int var3, Class568 var4) {
      if(null != var4) {
         var0.method12187(var1, var2, var3, var4.N(), var4.RA(), var4.ya(), var4.YA(), var4.o(), var4.AA(), var4.ha());
      }
   }

   abstract boolean method13447();

   static void method13448(Class571 var0, int var1, int var2, int var3, Class568 var4) {
      if(null != var4) {
         var0.method12187(var1, var2, var3, var4.N(), var4.RA(), var4.ya(), var4.YA(), var4.o(), var4.AA(), var4.ha());
      }
   }

   Class515_Sub1(Class241 var1) {
      this.aClass241_8441 = var1;
   }

   abstract boolean method13449();

   void method13450(int var1) {
      this.aClass89Array8446 = new Class89[var1];

      for(int var2 = 0; var2 < this.aClass89Array8446.length; ++var2) {
         this.aClass89Array8446[var2] = new Class89();
      }

   }

   abstract boolean method13451(byte var1);

   abstract boolean method13452(Class545 var1, int var2, int var3);

   void method13453(int var1) {
      this.aClass89Array8446 = new Class89[var1];

      for(int var2 = 0; var2 < this.aClass89Array8446.length; ++var2) {
         this.aClass89Array8446[var2] = new Class89();
      }

   }

   static final void method13454(Class508 var0, byte var1) {
      var0.anInt6005 -= -93697366;
      String var2 = (String)var0.anObjectArray6004[639741949 * var0.anInt6005];
      String var3 = (String)var0.anObjectArray6004[var0.anInt6005 * 639741949 + 1];
      var0.anInt6003 -= 196624946;
      int var4 = var0.anIntArray6027[var0.anInt6003 * -937710807];
      int var5 = var0.anIntArray6027[1 + var0.anInt6003 * -937710807];
      if(var3 == null) {
         var3 = "";
      }

      if(var3.length() > 80) {
         var3 = var3.substring(0, 80);
      }

      PacketContext var6 = Class35_Sub1.method13169(883808512);
      Class225_Sub15 var7 = Class543.method11415(OutgoingOpcode.aClass302_3783, var6.aClass433_2184, (byte)1);
      var7.buffer.writeByte(Class190.method3320(var2, 694260636) + 2 + Class190.method3320(var3, -1098807710), -765864773);
      var7.buffer.writeString(var2, (byte)49);
      var7.buffer.writeByte(var4 - 1, -765864773);
      var7.buffer.writeByte(var5, -765864773);
      var7.buffer.writeString(var3, (byte)67);
      var6.method3191(var7, (byte)0);
   }
}
